#!/usr/bin/perl

use strict;

use CGI; # Libreria CGI de Perl

# Recoge los parametros del formulario
my $form = new CGI;
my $seq = $form->param('secuencia');
my $pat = $form->param('patron');

my $found = 0; # comprueba si encontramos el patrn o no

# Encabezamiento http
print $form->header;

print <<HTML_TEXT;
<html>
<head>
  <meta content="text/html; charset=ISO-8859-1" http-equiv="content-type">
  <title>Bsqueda de patrones aminoacdicos</title>
</head>
<body>
HTML_TEXT

$seq =~ s/[\s\n\r]//g; # eliminar espacios y saltos de lnea
$seq = uc $seq; # pasar a mayscylas

# Comprobar si los parmetros son nmeros
if ($seq =~ /[^ACDEFGHIKLMNPQRSTVWXY\s\n\r]/ || $seq eq "") {
  &error ("La secuencia proteica es incorrecta");
  exit;
}

while ($seq =~ /($pat)/) {
  my $pos = length($`) + 1;
  print "<p>El patrn ha sido encontrado en la posicin $pos</p>\n";
  my $sustitucion = "-" x length($1);
  $seq =~ s/$1/$sustitucion/;
  $found = 1;
}

&error("Patrn no encontrado") if $found == 0;

print "</body></html>\n";

exit;

# Subrutinas
############
sub error () {
  my ($text) = @_;

  print "<p>Error! $text</p>\n";
  print "</body></html>\n";

  exit;
}

